<script lang="ts">
import Vue from 'vue';
import VueSlickCarousel from 'vue-slick-carousel';
import { IsMobileMixin } from '../../mixins';
import LaunchDarkly from '../../components/common/launch-darkly.vue';
import FeatureList from './feature-list.vue';
import PricingDedicatedCard from './plans/pricing-dedicated-card.vue';

export default Vue.extend({
  name: 'PricingTiersToggle',
  components: {
    VueSlickCarousel,
    FeatureList,
    PricingDedicatedCard,
    LaunchDarkly,
  },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Array,
      required: true,
      default: () => [],
    },
    audience: {
      type: String,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      activeTypeIndex: 0,
      activeCarouselIndex: 1,
    };
  },
  methods: {
    handleCarouselChange(index: number): void {
      this.activeCarouselIndex = index;
    },
    carouselGoTo(index: number): void {
      const carouselRef = this.$refs.carousel as any;
      this.activeCarouselIndex = index;
      if (carouselRef.goTo) {
        carouselRef.goTo(index);
      }
    },
    onChange(index, id) {
      this.activeTypeIndex = index;
      this.$emit('active-toggle-id', id);
    },
  },
});
</script>

<template>
  <div class="pricing-tiers-toggle">
    <div class="pricing-toggle">
      <div class="pricing-toggle__toggle">
        <div
          v-for="(tiersByType, index) in data"
          :key="tiersByType.name"
          :content="tiersByType.name"
          class="pricing-toggle__button"
          :class="{
            'pricing-toggle__button--active': activeTypeIndex == index,
          }"
          @click="onChange(index, tiersByType.id)"
        >
          <SlpTypography variant="body2">{{ tiersByType.label }}</SlpTypography>
        </div>
      </div>
      <transition name="slide-fade" mode="out-in" tag="div">
        <div :key="activeTypeIndex" class="pricing-toggle__legend">
          <SlpTypography variant="body2-bold">{{
            data[activeTypeIndex].description.text
          }}</SlpTypography>
          <SlpTooltip
            v-if="data[activeTypeIndex].description.tooltip"
            id="numberOfUsers"
            :text="data[activeTypeIndex].description.tooltip"
            position="top"
            mode="click"
            class="tooltip"
          >
            <SlpIcon
              variant="product"
              name="information-o"
              slp-color="text-link-100"
          /></SlpTooltip>
        </div>
      </transition>
    </div>
    <SlpContainer class="carousel-container">
      <div
        v-if="
          isMobile &&
          data[activeTypeIndex].tiers.length > 1 &&
          !data[activeTypeIndex].id.includes('dedicated')
        "
        class="carousel-controls"
      >
        <button
          class="free"
          :class="{ active: activeCarouselIndex === 0 }"
          @click="carouselGoTo(0)"
        >
          <SlpTypography variant="body1-bold">
            {{ data[activeTypeIndex].tiers[0].title }}
          </SlpTypography>
        </button>
        <button
          class="premium"
          :class="{ active: activeCarouselIndex === 1 }"
          @click="carouselGoTo(1)"
        >
          <SlpTypography variant="body1-bold">
            {{ data[activeTypeIndex].tiers[1].title }}
          </SlpTypography>
        </button>
        <button
          class="ultimate"
          :class="{ active: activeCarouselIndex === 2 }"
          @click="carouselGoTo(2)"
        >
          <SlpTypography variant="body1-bold">
            {{ data[activeTypeIndex].tiers[2].title }}
          </SlpTypography>
        </button>
      </div>
      <section class="tiers-section">
        <PricingDedicatedCard
          v-if="data[activeTypeIndex].id.includes('dedicated')"
          :data="data[activeTypeIndex].tiers"
        ></PricingDedicatedCard>
        <component
          :is="isMobile ? 'VueSlickCarousel' : 'slp-row'"
          v-else
          ref="carousel"
          center-mode
          :center-padding="`${width / 30}%`"
          :infinite="false"
          :dots="true"
          class="tiers"
          :initial-slide="1"
          @afterChange="handleCarouselChange"
        >
          <SlpColumn
            v-for="plan in data[activeTypeIndex].tiers"
            :key="plan.heading"
            class="column"
            :class="`${plan.id}-container`"
          >
            <div
              :class="[
                'tier',
                'pricing-tiers-toggle--experiment',
                `plan-${plan.id}`,
                { active: plan.id === audience },
              ]"
            >
              <SlpTypography
                v-if="plan.id === audience"
                variant="body2"
                class="tier-pill"
                >{{ plan.pill }}</SlpTypography
              >
              <div class="content">
                <SlpTypography
                  v-if="!isMobile"
                  tag="h2"
                  variant="heading3-bold"
                  class="title"
                  >{{ plan.title }}</SlpTypography
                >
                <SlpTypography
                  tag="p"
                  variant="body1-bold"
                  class="price-detail-container"
                >
                  {{ plan.subtitle }}</SlpTypography
                >
                <SlpTypography
                  v-if="plan.id === 'gold-ultimate'"
                  tag="p"
                  variant="body3"
                  class="price-detail-container price-blurb-container"
                  >{{ plan.blurb }}</SlpTypography
                >
                <span v-else-if="plan.id === 'silver-premium'">
                  <SlpTypography
                    tag="p"
                    variant="body3"
                    class="price-detail-container price-blurb-container show-if-india-flex"
                  >
                    For when your growing organization needs to automate
                    software delivery and improve collaboration between teams
                  </SlpTypography>
                  <div class="price-detail-container hide-if-india">
                    <div class="price-wrapper">
                      <div class="price-container">
                        <span class="dollar-sign"> $ </span>
                        <SlpTypography variant="heading1-bold" class="price">{{
                          plan.monthly_price
                        }}</SlpTypography>
                      </div>
                    </div>
                    <div class="price-detail-container__detail">
                      <SlpTypography
                        tag="p"
                        variant="body3"
                        class="price-monthly"
                        >{{ plan.price_text }}</SlpTypography
                      >
                      <SlpTypography
                        v-if="plan.monthly_price === 0"
                        tag="p"
                        variant="body3"
                        class="price-annually"
                      >
                        {{ plan.billing_type }}
                      </SlpTypography>
                      <SlpTypography
                        v-else
                        tag="p"
                        variant="body3"
                        class="price-annually"
                      >
                        {{ plan.billing_type }}
                      </SlpTypography>
                    </div>
                  </div>
                </span>
                <div
                  v-else-if="plan.id === 'free'"
                  class="price-detail-container"
                >
                  <div class="price-wrapper">
                    <div class="price-container">
                      <span class="dollar-sign"> $ </span>
                      <SlpTypography variant="heading1-bold" class="price">{{
                        plan.monthly_price
                      }}</SlpTypography>
                    </div>
                  </div>
                  <div class="price-detail-container__detail">
                    <SlpTypography
                      tag="p"
                      variant="body3"
                      class="price-monthly"
                      >{{ plan.price_text }}</SlpTypography
                    >
                    <SlpTypography
                      v-if="plan.monthly_price === 0"
                      tag="p"
                      variant="body3"
                      class="price-annually"
                    >
                      {{ plan.billing_type }}
                    </SlpTypography>
                    <SlpTypography
                      v-else
                      tag="p"
                      variant="body3"
                      class="price-annually"
                    >
                      {{ plan.billing_type }}
                    </SlpTypography>
                  </div>
                </div>

                <div>
                  <div v-if="plan.id === 'gold-ultimate'">
                    <SlpButton
                      :class="`buy-button-${plan.id} buy-button`"
                      variant="primary"
                      :data-ga-name="plan.additonal_button.data_ga_name"
                      :data-ga-location="plan.additonal_button.data_ga_location"
                      :href="plan.additonal_button.url"
                    >
                      {{ plan.additonal_button.text }}
                    </SlpButton>
                  </div>
                  <div v-else-if="plan.id === 'silver-premium'">
                    <SlpButton
                      :class="`buy-button-${plan.id} buy-button show-if-india-inline-flex`"
                      variant="primary"
                      data-ga-name="sales"
                      data-ga-location="saas pricing"
                      href="/sales"
                    >
                      Contact Sales
                    </SlpButton>

                    <SlpButton
                      :class="`buy-button-${plan.id} buy-button hide-if-india`"
                      variant="primary"
                      :data-ga-name="plan.button.data_ga_name"
                      :data-ga-location="plan.button.data_ga_location"
                      :href="plan.button.url"
                    >
                      {{ plan.button.text }}
                    </SlpButton>
                  </div>
                  <div v-else-if="plan.id === 'free'">
                    <SlpButton
                      :class="`buy-button-${plan.id} buy-button`"
                      :variant="plan.id === 'free' ? 'tertiary' : 'primary'"
                      :data-ga-name="plan.button.data_ga_name"
                      :data-ga-location="plan.button.data_ga_location"
                      :href="plan.button.url"
                    >
                      {{ plan.button.text }}
                      <SlpIcon
                        v-if="plan.id === 'free'"
                        class="slp-ml-16"
                        name="chevron-lg-right"
                        variant="product"
                        slp-color="primary-200"
                        alt="Chevron Right Icon"
                      />
                    </SlpButton>
                  </div>
                </div>

                <SlpButton
                  v-if="plan.additonal_button && plan.id !== 'gold-ultimate'"
                  variant="tertiary"
                  class="slp-mt-8"
                  :href="plan.additonal_button.url"
                  :data-ga-name="plan.additonal_button.data_ga_name"
                  :data-ga-location="plan.additonal_button.data_ga_location"
                >
                  {{ plan.additonal_button.text }}
                  <SlpIcon
                    class="slp-ml-16"
                    name="chevron-lg-right"
                    variant="product"
                    slp-color="primary-200"
                    alt="Chevron Right Icon"
                  />
                </SlpButton>
              </div>
            </div>
            <FeatureList
              :data="plan.features"
              :tooltip-position="isMobile ? 'bottom' : 'right'"
            />
            <div v-if="plan.info_box?.title" class="pricing-toggle__info-box">
              <SlpTypography variant="heading5-bold" class="slp-mb-8" tag="p">
                {{ plan.info_box.title }}
              </SlpTypography>
              <SlpTypography variant="body1">
                <div v-html="plan.info_box.description"></div>
              </SlpTypography>
            </div>
          </SlpColumn>
        </component>
      </section>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.show-if-india-flex,
.show-if-india-inline-flex {
  display: none !important;
}

[data-country-code='in'] {
  .show-if-india-flex {
    display: flex !important;
  }
  .show-if-india-inline-flex {
    display: inline-flex !important;
  }
  .hide-if-india {
    display: none !important;
  }
}

.pricing-tiers-toggle {
  .pricing-toggle {
    padding: 16px;
    margin: 32px auto 16px auto;
    @media (min-width: $breakpoint-md) {
      padding: 0;
    }
    &__toggle {
      border-radius: 20px;
      border: 1px solid $color-text-link-100;
      display: inline-flex;
      background: $color-surface-800;
      overflow: hidden;
    }

    &__button {
      cursor: pointer;
      position: relative;
      color: $color-text-200;
      padding: $spacing-8 $spacing-16;

      :deep span {
        display: block;
        position: relative;
      }
      &--active {
        // font-weight: bold;
        color: $color-text-300;
        :deep span {
          font-weight: bold;

          // transition: all 0.3s ease;
        }
        &:before {
          content: '';
          position: absolute;
          height: 100%;
          width: 100%;
          background: $color-surface-900;
          top: 0;
          left: 0;
          border-radius: 20px;
        }
      }
      &:after {
        display: block;
        content: attr(content);
        font-weight: bold;
        height: 1px;
        color: transparent;
        overflow: hidden;
        visibility: hidden;
      }
    }
    &__legend {
      display: inline-block;
      margin-top: $spacing-16;
      @media (min-width: $breakpoint-md) {
        margin-top: 0;
        margin-left: $spacing-16;
      }

      :deep {
        .slp-tooltip {
          border: none;
          top: 2.5px;
          margin-right: -$spacing-16;
          padding: 0;
        }
        .slp-tooltip__content {
          @media (min-width: $breakpoint-md) {
            width: 175px;
          }
        }
      }
    }
    &__info-box {
      background: $color-surface-800;
      border-radius: 4px;
      padding: 16px;
      margin-top: $spacing-24;
    }
  }

  .carousel-container {
    @media (max-width: $breakpoint-lg) {
      overflow: hidden;
    }
  }
  .slide-fade-enter-active {
    transition: all 0.5s;
  }

  .slide-fade-leave-active {
    transition: all 0.3s ease-in;
  }

  .slide-fade-enter,
  .slide-fade-leave-to {
    transform: translateX(20px);
    opacity: 0;
    @media (prefers-reduced-motion) {
      opacity: 1;
      transform: none;
    }
  }
  .slide-fade-leave,
  .slide-fade-enter-to {
    opacity: 1;
  }

  .tiers-section {
    &:deep .slick-dots {
      bottom: -23px;
    }
  }

  div.slp-col-md.column {
    height: 100%;
    padding: 0 $spacing-8;
    position: relative;
    width: 366px;
    max-width: 366px;

    &.free-container {
      z-index: 2;
    }
    &.silver-premium-container {
      z-index: 1;
    }
    &.gold-ultimate-container {
      z-index: 0;
    }

    @media (min-width: $breakpoint-sm) and (max-width: $breakpoint-lg) {
      width: 331px;
      max-width: 331px;
    }

    @media (max-width: $breakpoint-sm) {
      width: 286px;
      max-width: 286px;
    }
  }

  div.carousel-container {
    @media (max-width: $breakpoint-lg) {
      padding-right: 0;
      padding-left: 0;
    }
  }

  .carousel-controls {
    display: flex;
    width: 100%;
    justify-content: space-around;
    height: 42px;
    margin-top: $spacing-24;
    button {
      border: none;
      width: 100%;
      border-bottom: 1px solid transparent;
      opacity: 0.2;
      color: $color-primary-200;
      &.active {
        border-bottom: 1px solid #171321;
        opacity: 1;
      }
    }
  }

  .tiers {
    margin: $spacing-24 auto;
    justify-content: space-between;

    @media (max-width: $breakpoint-lg) {
      margin: $spacing-16 auto;
    }

    .tier {
      text-align: left;
      border-radius: $border-radius-4;
      border-style: solid;
      border: 1px solid transparent;
      padding: $spacing-24;
      margin: 0 auto $spacing-32;
      min-height: 322px;
      @media (min-width: $breakpoint-sm) {
        min-height: 432px;
      }
      @media (min-width: $breakpoint-lg) {
        min-height: 362px;
      }
      &.pricing-tiers-toggle--experiment {
        padding-top: $spacing-48;
        padding-bottom: $spacing-48;
        min-height: 326px;
        @media (min-width: $breakpoint-sm) {
          min-height: 294px;
        }
        @media (min-width: $breakpoint-md) {
          min-height: 437px;
        }
        @media (min-width: $breakpoint-lg) {
          min-height: 342px;
        }
      }

      .tier-pill {
        background-color: $color-accent-500;
        color: $color-text-50;
        position: absolute;
        padding: $spacing-8 $spacing-16;
        border-radius: 20px;
        top: -17px;
      }

      &.plan-free {
        background-color: $color-surface-100;
        .asterisk {
          vertical-align: top;
        }
        button,
        a {
          padding-left: 0;
        }
        @media (max-width: $breakpoint-sm) {
          .description {
            margin-bottom: $spacing-32;
          }
        }
      }
      &.plan-silver-premium {
        background-color: $color-surface-900;

        &.active {
          border: 2px solid $color-accent-500;
        }
      }

      &.plan-gold-ultimate {
        border-radius: 4px 4px 100px 4px;
        background: url('/nuxt-images/backgrounds/ultimate_tier_gradient.png');
        border: 1px solid $color-surface-900;
        background-size: cover;
        background-repeat: no-repeat;
        background-position: center center;

        &.active {
          border: 2px solid $color-accent-500;
        }

        @media (max-width: $breakpoint-lg) {
          border-radius: 4px 4px 70px 4px;
        }
      }
    }

    .content {
      height: 100%;

      .description {
        margin-bottom: $spacing-8;
      }

      .price-detail-container {
        display: flex;
        flex-direction: row;
        margin-bottom: $spacing-16;

        &__detail {
          display: flex;
          flex-direction: column;
          justify-content: center;
          margin-left: 8px;
        }

        .price-wrapper {
          display: flex;

          @media (max-width: $breakpoint-lg) {
            flex-direction: column;
          }
        }

        .price-container {
          display: flex;
          margin-right: $spacing-8;

          .dollar-sign {
            position: relative;
            top: 15px;

            @media (max-width: $breakpoint-lg) {
              position: initial;
            }
          }
        }
      }
    }
  }

  .card {
    a {
      font-weight: $font-weight-bold;
      color: $color-text-link-100;
      font-size: $text-body-2;
    }

    h3 {
      margin-bottom: $spacing-16;
    }
  }
  .price-blurb-container {
    @media (min-width: $breakpoint-lg) {
      margin-bottom: 28px !important;
    }
  }
}
</style>
